Graphics 640, 480, 0, 2
SetBuffer BackBuffer()
SeedRnd MilliSecs()
Global tmrFPS = CreateTimer(60)
AppTitle "nPoly Demo"

Include "nPoly.bb"

gear1 = nP_CreatePoly()
nP_AddVertex(gear1, 0, -50, False)
nP_AddVertex(gear1, 10, -10, False)
nP_AddVertex(gear1, 50, 0, False)
nP_AddVertex(gear1, 10, 10, False)
nP_AddVertex(gear1, 0, 50, False)
nP_AddVertex(gear1, -10, 10, False)
nP_AddVertex(gear1, -50, 0, False)
nP_AddVertex(gear1, -10, -10, False)
nP_AddVertex(gear1, 0, -50)
gear2 = nP_CopyPoly(gear1)
nP_ScalePoly(gear2, 0.7, 0.7)

lever = nP_CreatePoly()
nP_AddVertex(lever, -100, 5, False)
nP_AddVertex(lever, 0, 5, False)
nP_AddVertex(lever, 0, -5, False)
nP_AddVertex(lever, -100, -5, False)
nP_AddVertex(lever, -100, 5)

Const MAXC = 4
Dim cylinder(MAXC)
Dim cy(MAXC)
cylinder(0) = nP_CreatePoly()
nP_AddVertex(cylinder(0), -9, 20, False)
nP_AddVertex(cylinder(0), 9, 20, False)
nP_AddVertex(cylinder(0), 9, -20, False)
nP_AddVertex(cylinder(0), -9, -20, False)
nP_AddVertex(cylinder(0), -9, 20)
cy(0) = 100
For i = 1 To MAXC
	cylinder(i) = nP_CopyPoly(cylinder(0))
	cy(i) = cy(0)
Next

box = nP_CreatePoly()
nP_AddVertex(box, 0, 0, False)
nP_AddVertex(box, 200, 0, False)
nP_AddVertex(box, 170, 70, False)
nP_AddVertex(box, 200, 200, False)
nP_AddVertex(box, 30, 200, False)
nP_AddVertex(box, 65, 130, False)
nP_AddVertex(box, 0, 180, False)
nP_AddVertex(box, 0, 0)
rad = 15

maxb = 150
maxr = 15

minx = 20
miny = 270
maxx = 620
maxy = 460

Type ball
	Field poly
	Field rad
	Field x#
	Field y#
	Field velx#
	Field vely#
End Type

For i = 1 To maxb
	balls.ball = New ball
	balls\x = Rnd(minx + maxr, maxx - maxr)
	balls\y = Rnd(miny + maxr, maxy - maxr)
	balls\rad = Rnd(4, maxr)
	k = False
	For b.ball = Each ball
		If b <> balls Then
			If nP_CirclesOverlap(balls\x, balls\y, balls\rad, b\x, b\y, b\rad) Then
				Delete balls
				k = True
				Exit
			End If
		End If
	Next
	If Not k Then
		balls\velx = Rnd(0, 3) - 1.5
		balls\vely = Rnd(0, 3) - 1.5
		If Rand(1, 3) > 1 And balls\rad > 4 Then
			balls\poly = nP_CreatePoly()
			brad# = balls\rad
			srad# = Rand(2, balls\rad - 2)
			pikes = Rand(3, 7)
			deg = 0
			degstep = 180 / pikes
			For j = 1 To pikes
				nP_AddVertex(balls\poly, brad*Cos(deg), brad*Sin(deg), False)
				deg = deg + degstep
				nP_AddVertex(balls\poly, srad*Cos(deg), srad*Sin(deg), False)
				deg = deg + degstep
			Next
			nP_AddVertex(balls\poly, brad*Cos(deg), brad*Sin(deg), False)
		End If
	End If
Next

While Not KeyDown(1)

	starttmr = MilliSecs()
	WaitTimer tmrFPS
	endtmr = MilliSecs()
	timFPS = timFPS + endtmr - starttmr

	If MilliSecs() > timFPS Then
		timFPS = MilliSecs() + 1000
		lastFPS = FPS
		FPS = 0
	Else
		FPS = FPS + 1
	End If
	
	framestart = MilliSecs()
	colchecks = 0
	colchecks2 = 0
	colchecks3 = 0
	
	Cls
	
	nP_RotatePoly(gear1, 1)
	colchecks = colchecks + 1
	; Gears
	While nP_PolyOverlap(gear1, 150, 150, gear2, 212, 150, False)
		nP_RotatePoly(gear2, -1)
		colchecks = colchecks + 1
	Wend
	colchecks = colchecks + 1
	; Gear and lever
	If Not nP_PolyOverlap(gear2, 212, 150, lever, 320, 130, False)
		nP_RotatePoly(lever, -1)
	End If
	colchecks = colchecks + 1
	While nP_PolyOverlap(gear2, 212, 150, lever, 320, 130, False)
		nP_RotatePoly(lever, 1)
		colchecks = colchecks + 1
	Wend
	
	; Cylinders with lever
	For i = 0 To MAXC
		colchecks = colchecks + 1
		If Not nP_PolyOverlap(cylinder(i), 230 + 22 * i, cy(i), lever, 320, 130, False)
			cy(i) = cy(i) + 3
		End If	
		colchecks = colchecks + 1
		While nP_PolyOverlap(cylinder(i), 230 + 22 * i, cy(i), lever, 320, 130, False)
			cy(i) = cy(i) - 1
			colchecks = colchecks + 1
		Wend
	Next

	; Resize box and mouse ball
	If KeyDown(200) Then
		nP_ScalePoly(box, 1.01, 1.01)
	End If
	If KeyDown(208) Then
		nP_ScalePoly(box, 0.99, 0.99)
	End If
	If KeyDown(203) Then
		nP_RotatePoly(box, 3)
	End If
	If KeyDown(205) Then
		nP_RotatePoly(box, -3)
	End If
	rad = 15 + MouseZ() * 3
	mx = MouseX()
	my = MouseY()

	nP_DrawPoly(gear1, 150, 150, 255, 0, 0, False)
	nP_DrawPoly(gear2, 212, 150, 255, 0, 0, False)
	nP_DrawPoly(lever, 320, 130, 255, 0, 0, False)
	For i = 0 To MAXC
		nP_DrawPoly(cylinder(i), 230 + 22 * i, cy(i), 255, 0, 0, False)
	Next
	Text 110, 200, "All polygonal collisions"
	Text 110, 215, "done real-time"
	nP_DrawPoly(box, 400, 50, 255, 255, 0, False)
	Text 400, 5, "Hover mouse about this box"
	Text 400, 20, "Arrow keys, mouse wheel"
	colchecks2 = colchecks2 + 1
	If nP_PolyOverlapsCircle(box, 400, 50, mx, my, rad, False)
		Color 0, 0, 255
	Else
		Color 255, 255, 255
	End If
	Oval mx - rad, my - rad, rad*2, rad*2
	Color 0, 255, 0
	Rect minx, miny, maxx - minx, maxy - miny, False
	For balls.ball = Each ball
		balls\x = balls\x + balls\velx
		balls\y = balls\y + balls\vely
		If balls\x + balls\rad >= maxx Or balls\x - balls\rad <= minx Then
			balls\velx = -balls\velx
		End If
		If balls\y + balls\rad >= maxy Or balls\y - balls\rad <= miny Then
			balls\vely = -balls\vely
		End If
		If balls\poly = 0 Then
			Oval balls\x - balls\rad, balls\y - balls\rad, balls\rad*2, balls\rad*2
		Else
			nP_RotatePoly(balls\poly, balls\velx - balls\vely)
			nP_DrawPoly(balls\poly, balls\x, balls\y, 0, 255, 0, False)
		End If
		For b.ball = Each ball
			If b <> balls Then
				If b\poly = 0 And balls\poly = 0 Then
					colchecks3 = colchecks3 + 1
					col = nP_CirclesOverlap(balls\x, balls\y, balls\rad, b\x, b\y, b\rad)
				ElseIf b\poly = 0 Then
					colchecks2 = colchecks2 + 1
					col = nP_PolyOverlapsCircle(balls\poly, balls\x, balls\y, b\x, b\y, b\rad)
				ElseIf balls\poly = 0 Then
					colchecks2 = colchecks2 + 1
					col = nP_PolyOverlapsCircle(b\poly, b\x, b\y, balls\x, balls\y, balls\rad)
				Else
					colchecks = colchecks + 1
					col = nP_PolyOverlap(balls\poly, balls\x, balls\y, b\poly, b\x, b\y)
				End If
				If col Then
					x# = balls\x - b\x
					y# = balls\y - b\y
					balls\velx = Abs(balls\velx) * Sgn(x#)
					balls\vely = Abs(balls\vely) * Sgn(y#)
					b\velx = Abs(b\velx) * -Sgn(x#)
					b\vely = Abs(b\vely) * -Sgn(y#)
					tx# = balls\velx * 0.7 + Abs(b\velx) * Sgn(x#) * 0.3
					ty# = balls\vely * 0.7 + Abs(b\vely) * Sgn(y#) * 0.3
					b\velx = b\velx * 0.7 + Abs(balls\velx) * -Sgn(x#) * 0.3
					b\vely = b\vely * 0.7 + Abs(balls\vely) * -Sgn(y#) * 0.3
					balls\velx = tx#
					balls\vely = ty#
					Exit
				End If
			End If
		Next
	Next

	Color 255, 255, 255
	Text 0, 0, "FPS: " + lastfps
	Text 0, 15, "Collision checks:"
	Text 0, 30, "Poly vs poly:     " + colchecks
	Text 0, 45, "Poly vs circle:   " + colchecks2
	Text 0, 60, "Circle vs circle: " + colchecks3
	Text 0, 75, "Total:            " + (colchecks + colchecks2 + colchecks3)
	
	Flip False

Wend

End